#!/bin/bash

CHROOT_DIR="$1"

echo "UnMounting binfmt_misc ..."
umount /proc/sys/fs/binfmt_misc
echo "Mounting binfmt_misc ..."
mount -t binfmt_misc none /proc/sys/fs/binfmt_misc
echo "Register handler for ARM ELF ..."
echo "-1" > /proc/sys/fs/binfmt_misc/arm
echo ":arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:" > /proc/sys/fs/binfmt_misc/register

if [ `grep -c "${CHROOT_DIR}/proc" /proc/mounts` -eq 0 ] ; then mount -o bind /proc ${CHROOT_DIR}/proc ; fi
if [ `grep -c "${CHROOT_DIR}/sys" /proc/mounts` -eq 0 ] ; then mount -o bind /sys ${CHROOT_DIR}/sys ; fi
if [ `grep -c "${CHROOT_DIR}/dev/pts" /proc/mounts` -eq 0 ] ; then mount -o bind /dev/pts ${CHROOT_DIR}/dev/pts ; fi

if [ "${CHROOT_DIR}" = "" ]; then
    chroot ./chroot
else
    chroot ${CHROOT_DIR}
fi
